package com.maroontress.gcovparser.gcda;

import com.maroontress.gcovparser.Parser;
import com.maroontress.gcovparser.Tag;
import com.maroontress.gcovparser.UnexpectedTagException;
import java.io.IOException;
import java.nio.ByteBuffer;

/**
   ؿǡ쥳ɤǤ

   function-data: announce_function arc_counts
   announce_function: header int32:ident int32:checksum
   arc_counts: header int64:count*
*/
public final class FunctionDataRecord {

    /** ̻ҤǤ */
    private int id;

    /** ؿΥåǤ */
    private int checksum;

    /** ARCS쥳ɤΥꥹȤǤ */
    private long[] arcCounts;

    /**
       ХȥХåեFUNCTION_DATA쥳ɤϤƥ󥹥󥹤
       ޤХȥХåեΰ֤FUNCTION_DATA쥳ɤΥ
       Ϥľΰ֤ǤʤФʤޤϡХ
       Хåեΰ֤FUNCTION_DATA쥳ɤμΰ֤˰ưޤ

       @param bb ХȥХåե
       @throws IOException ϥ顼
       @throws UnexpectedTagException ͽʤ򸡽
    */
    public FunctionDataRecord(final ByteBuffer bb)
	throws IOException, UnexpectedTagException {
	int length = bb.getInt();
	int next = bb.position() + Parser.SIZE_INT32 * length;

	id = bb.getInt();
	checksum = bb.getInt();
	bb.position(next);

	int tag = bb.getInt();
	if (tag != Tag.ARC_COUNTS) {
	    String m = String.format("unexpected tag: 0x%x", tag);
	    throw new UnexpectedTagException(m);
	}
	length = bb.getInt();
	next = bb.position() + Parser.SIZE_INT32 * length;

	arcCounts = new long[length / 2];
	for (int k = 0; k < arcCounts.length; ++k) {
	    arcCounts[k] = Parser.getInt64(bb);
	}
	bb.position(next);
    }

    /**
       ̻Ҥޤ

       @return ̻
    */
    public int getId() {
	return id;
    }

    /**
       ؿΥåޤ

       @return ؿΥå
    */
    public int getChecksum() {
	return checksum;
    }

    /**
       Ȥޤ

       @return 
    */
    public long[] getArcCounts() {
	return arcCounts;
    }
}
